<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ImpactoManutService;

class ImpactoManutController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $ImpactoManutService;

    public function __construct($crudService, $environment, ImpactoManutService $ImpactoManutService) {
        parent::__construct($crudService, $environment);
        $this->ImpactoManutService = $ImpactoManutService;
    }

    public function rotaBase(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $impacto = '';

        if ($method== "POST") {
            $impacto = $this->ImpactoManutService-> inserirImpacto($parametros);
        } else if ($method == "GET") {
           $impacto = $this->ImpactoManutService->getInformacoesImpacto();
        }

        $dtsVal = new DataSet('impacto', [$impacto]);
        $response->addDataSet($dtsVal);
    }
}

?>