<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class FotoTarefaGerChkFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }   
    
    public function salvarImagem($param) {
        $sql = "INSERT INTO FCM_FOTOTAREFAGERCHK(NRFOTOTAREFAGERCHK, NRTAREFAGERCHK, DSFOTOTAREFAGERCHK, IDATIVO, NRORG, DTINCLUSAO,
                                                CDOPERINCLUSAO, NRORGINCLUSAO, DTULTATU, CDOPERULTATU, NRORGULTATU, DSTYPE, QTSIZE)
                                         VALUES(:NRFOTOTAREFAGERCHK, (SELECT MIN(NRTAREFAGERCHK) AS NRTAREFAGERCHK FROM FCM_TAREFAGERCHK WHERE NRGERENCIAMENTOCHK = :NRTAREFAGERCHK), :DSFOTOTAREFAGERCHK, 'S', :NRORG, SYSDATE,
                                                :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE, :CDOPERULTATU, :NRORGULTATU, :DSTYPE,
                                                :QTSIZE)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
        
    public function getFoto($param) {

        $sql = "SELECT NRFOTOTAREFAGERCHK, DSFOTOTAREFAGERCHK
                  FROM FCM_FOTOTAREFAGERCHK
                 WHERE NRTAREFAGERCHK = (SELECT MIN(NRTAREFAGERCHK) AS NRTAREFAGERCHK FROM FCM_TAREFAGERCHK WHERE NRGERENCIAMENTOCHK = :NRTAREFAGERCHK)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }
        
    public function deleteFoto($param) {

        $sql = "DELETE FROM FCM_FOTOTAREFAGERCHK
                 WHERE NRFOTOTAREFAGERCHK = :NRFOTOTAREFAGERCHK
                   AND NRTAREFAGERCHK = (SELECT MIN(NRTAREFAGERCHK) AS NRTAREFAGERCHK FROM FCM_TAREFAGERCHK WHERE NRGERENCIAMENTOCHK = :NRTAREFAGERCHK)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
}

?>