<?php

namespace FM\Service;

use FM\Factory\CategoriaEquipFactory;
use FM\Factory\RelcategoriaequipmanutFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CategoriaEquipService {

    protected $CategoriaEquipFactory;
    protected $RelcategoriaequipmanutFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (CategoriaEquipFactory $CategoriaEquipFactory, RelcategoriaequipmanutFactory $RelcategoriaequipmanutFactory, EntityManager $entityManager, Environment $Environment, NewCode $newCode) {
        $this->CategoriaEquipFactory = $CategoriaEquipFactory;
        $this->RelcategoriaequipmanutFactory = $RelcategoriaequipmanutFactory;
        $this->connection = $entityManager->getConnection();
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }
    
    public function dadosCategoria(){
        return $this->CategoriaEquipFactory->dadosCategoria();
    }
    
    public function categoria(){
        return $this->CategoriaEquipFactory->categoria();
    }
    
    public function insertCategoria($param){
        $this->connection->beginTransaction();
        
        try {
            $nrcategoria = $this->newCode->getCodeByTableName("FCM_CATEGORIAEQUIP", 20, 1, 10, true);
            $this->CategoriaEquipFactory->insertCategoria(array(
                "NRCATEGORIAEQUIP" => $nrcategoria,
                "NMCATEGORIAEQUIP" => $param["NOME"], 
                "NRORG" => 20,
            ));
            
            foreach($param['TIPOMANUT'] as $manut){
                $this->RelcategoriaequipmanutFactory->insertRelCatManut(array(
                    "NRRELCATEGORIAEQUIPMANUT" => $this->newCode->getCodeByTableName("FCM_RELCATEGORIAEQUIPMANUT", 20, 1, 10, true),
                    "NRCATEGORIAEQUIP" => $nrcategoria,
                    "NRCATEGORIAMANUT" => $manut,
                    "NRORG" => 20
                ));
            }
            
            $this->connection->commit();
            $response = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $response = ($e->getMessage());
        }
        return $response;
    }
}

?>