CREATE OR REPLACE TRIGGER STATUS_LOTECTB_LANCTOESTOQ BEFORE DELETE ON LANCTOESTOQ
FOR EACH ROW
DECLARE
  V_CDLOTE VARCHAR2(20);
  V_NRLANCLOTE VARCHAR2(06);
  V_DTINICCTBL DATE;
  V_DTFINACCTBL DATE;
  V_CDEMPRESA VARCHAR2(02);
  V_IDTPGERACAOCONT VARCHAR2(02);
BEGIN
   BEGIN
      SELECT IDTPGERACAOCONT
        INTO V_IDTPGERACAOCONT
        FROM PARAMCTBL;
   EXCEPTION
    WHEN NO_DATA_FOUND THEN
      V_IDTPGERACAOCONT := NULL;
   END;

   IF V_IDTPGERACAOCONT <> 'O' THEN

      BEGIN
         SELECT CDEMPRESA
           INTO V_CDEMPRESA
           FROM FILIAL
          WHERE CDFILIAL = :OLD.CDFILIAL;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          V_CDEMPRESA := NULL;
      END;

      BEGIN
         SELECT DTINIINTCONTDFE, DTFININTCONTDFE
           INTO V_DTINICCTBL, V_DTFINACCTBL
           FROM CONTOPECTBL
          WHERE CDEMPRESA = V_CDEMPRESA;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
         V_DTINICCTBL := NULL;
         V_DTFINACCTBL := NULL;
      END;

      IF DELETING THEN
         IF :OLD.DTLANCESTQ >= V_DTINICCTBL AND :OLD.DTLANCESTQ <= V_DTFINACCTBL THEN
            BEGIN
               SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                 INTO V_CDLOTE, V_NRLANCLOTE
                 FROM RELALESTLANCLOT
                WHERE CDFILIAL = :OLD.CDFILIAL
                  AND NRLANCESTQ = :OLD.NRLANCESTQ;

            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_CDLOTE := NULL;
                 V_NRLANCLOTE := NULL;
            END;

            REVERTE_LOTE(V_CDEMPRESA,V_CDLOTE);

            DELETE FROM RELALESTLANCLOT
             WHERE CDEMPRESA = V_CDEMPRESA
               AND CDLOTE = V_CDLOTE
               AND NRLANCLOTE = V_NRLANCLOTE
               AND CDFILIAL = :OLD.CDFILIAL
               AND NRLANCESTQ = :OLD.NRLANCESTQ;

            DELETE FROM LANCLOTE
             WHERE CDEMPRESA = V_CDEMPRESA
               AND CDLOTE = V_CDLOTE
               AND NRLANCLOTE = V_NRLANCLOTE;
         ELSE
            RAISE_APPLICATION_ERROR(-20501,'Excluso no permitida, lanamento fora do perodo de integrao DFE.',True);
         END IF;
      END IF;
   END IF;
END;
/






