/* Sistemas Integrados TECNISA

Nome: 5031_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   01/08/2012 - Marcelo Alexsandro

Tabela GRUPOFISCREGRA: Grupo Fiscal da Regra.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela GRUPOFISCREGRA
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_GRUPOFISCREGRA' AND
                 TYPE   = 'TR' 	           AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_GRUPOFISCREGRA
GO

CREATE TRIGGER LOG_FIS_GRUPOFISCREGRA
ON GRUPOFISCREGRA
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO    VARCHAR(40);
   DECLARE @V_DTOPER     DATETIME;

   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_DESC       VARCHAR(350);
   DECLARE @V_ITPESQ     VARCHAR(40);
   DECLARE @V_NMOPERADOR VARCHAR(40);
   DECLARE @V_IDTIPOOPER VARCHAR(1);

   DECLARE @V_CDREGRAFISC_OLD     VARCHAR(10);
   DECLARE @V_CDGRUPOFISC_OLD     VARCHAR(3);

   DECLARE @V_CDREGRAFISC_NEW     VARCHAR(10);
   DECLARE @V_CDGRUPOFISC_NEW     VARCHAR(3);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @V_NMOPERADOR;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.CDGRUPOFISC,
     NULL,
     NULL
   FROM
     DELETED
   WHERE
     CDREGRAFISC+CDGRUPOFISC NOT IN (SELECT CDREGRAFISC+CDGRUPOFISC FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.CDGRUPOFISC,
     INSERTED.CDREGRAFISC,
     INSERTED.CDGRUPOFISC
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDREGRAFISC = DELETED.CDREGRAFISC
     AND INSERTED.CDGRUPOFISC = DELETED.CDGRUPOFISC

   UNION ALL

   SELECT
     'I' IDCOMANDO,
     NULL,
     NULL,
     INSERTED.CDREGRAFISC,
     INSERTED.CDGRUPOFISC
   FROM INSERTED
   WHERE CDREGRAFISC+CDGRUPOFISC NOT IN (SELECT CDREGRAFISC+CDGRUPOFISC FROM DELETED);
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDREGRAFISC_OLD,
                                 @V_CDGRUPOFISC_OLD,
                                 @V_CDREGRAFISC_NEW,
                                 @V_CDGRUPOFISC_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SET @V_DESC   = 'Grupo = ' + @V_CDGRUPOFISC_NEW;
         SET @V_ITPESQ = @V_CDREGRAFISC_NEW+CONVERT(VARCHAR,@V_CDGRUPOFISC_NEW);
         SET @V_IDTIPOOPER = '2';
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'I' BEGIN
            SET @V_DESC   = 'Grupo = ' + @V_CDGRUPOFISC_NEW;
            SET @V_ITPESQ = @V_CDREGRAFISC_NEW+CONVERT(VARCHAR,@V_CDGRUPOFISC_NEW);
            SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               SET @V_DESC   = 'Grupo = ' + @V_CDGRUPOFISC_OLD;
               SET @V_ITPESQ = @V_CDREGRAFISC_OLD+CONVERT(VARCHAR,@V_CDGRUPOFISC_OLD);
               SET @V_IDTIPOOPER = '3';
            END;
         END;
      END;
      INSERT INTO LOGREGRAFISCAL
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM)
       VALUES
         ('GRUPOFISCREGRA',
          GETDATE(),
          ISNULL(@V_NMOPERADOR,' '),
          @V_IDTIPOOPER,
          @V_DESC,
          @V_ITPESQ);
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDREGRAFISC_OLD,
                                    @V_CDGRUPOFISC_OLD,
                                    @V_CDREGRAFISC_NEW,
                                    @V_CDGRUPOFISC_NEW;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_GRUPOFISCREGRA','5.33.xxx';
GO
